package RunningFromChaos;
import java.awt.Color;

public class FourBitColor {

    public int R;
    public int G;
    public int B;
    public boolean A;

    public FourBitColor(int red, int green, int blue, boolean alpha) {
        R = red;
        G = green;
        B = blue;
        A = alpha;
    }

    public FourBitColor(int red, int green, int blue) {
        R = red;
        G = green;
        B = blue;
        A = false;
    }

    public FourBitColor(boolean alpha) {
        R = 0;
        G = 0;
        B = 0;
        A = alpha;
    }

    public Color ToAWT() {
        return new Color(R, G, B);
    }

    public static FourBitColor ColorFromNum(byte cl) {
        switch (cl) {
            case 0:
                return Alpha;
            case 1:
                return Black;
            case 2:
                return Gray25;
            case 3:
                return Gray50;
            case 4:
                return White;
            case 5:
                return DarkRed;
            case 6:
                return Red;
            case 7:
                return Pink;
            case 8:
                return Teal;
            case 9:
                return Green;
            case 10:
                return BrightGreen;
            case 11:
                return Turquoise;
            case 12:
                return DarkBlue;
            case 13:
                return Violet;
            case 14:
                return Blue;
            case 15:
                return DarkYellow;
            case 16:
                return Yellow;
            default:
                return Black;
        }
    }

    public static FourBitColor ColorFromChar(char cl) {
        switch (cl) {
            case 'A':
                return Alpha;
            case 'B':
                return Black;
            case 'C':
                return Gray25;
            case 'D':
                return Gray50;
            case 'E':
                return White;
            case 'F':
                return DarkRed;
            case 'G':
                return Red;
            case 'H':
                return Pink;
            case 'I':
                return Teal;
            case 'J':
                return Green;
            case 'K':
                return BrightGreen;
            case 'L':
                return Turquoise;
            case 'M':
                return DarkBlue;
            case 'N':
                return Violet;
            case 'O':
                return Blue;
            case 'P':
                return DarkYellow;
            case 'Q':
                return Yellow;
            default:
                return Black;
        }
    }

    public static FourBitColor BlackColorFromChar(char cl) {
        switch (cl) {
            case 'A':
                return Alpha;
            case 'B':
                return Black;
            case 'C':
                return White;
            case 'D':
                return Black;
            case 'E':
                return White;
            case 'F':
                return Black;
            case 'G':
                return White;
            case 'H':
                return White;
            case 'I':
                return Black;
            case 'J':
                return Black;
            case 'K':
                return White;
            case 'L':
                return White;
            case 'M':
                return Black;
            case 'N':
                return Black;
            case 'O':
                return Black;
            case 'P':
                return Black;
            case 'Q':
                return White;
            default:
                return Black;
        }
    }

    public static FourBitColor GrayColorFromChar(char cl) {
        switch (cl) {
            case 'A':
                return Alpha;
            case 'B':
                return Black;
            case 'C':
                return Gray25;
            case 'D':
                return Gray50;
            case 'E':
                return White;
            case 'F':
                return Black;
            case 'G':
                return Gray50;
            case 'H':
                return Gray25;
            case 'I':
                return Gray50;
            case 'J':
                return Gray50;
            case 'K':
                return White;
            case 'L':
                return White;
            case 'M':
                return Black;
            case 'N':
                return Gray50;
            case 'O':
                return Gray50;
            case 'P':
                return Gray50;
            case 'Q':
                return White;
            default:
                return Black;
        }
    }
    public static FourBitColor Black = new FourBitColor(0, 0, 0);
    public static FourBitColor Gray25 = new FourBitColor(192, 192, 192);
    public static FourBitColor Gray50 = new FourBitColor(128, 128, 128);
    public static FourBitColor White = new FourBitColor(255, 255, 255);
    public static FourBitColor DarkRed = new FourBitColor(128, 0, 0);
    public static FourBitColor Red = new FourBitColor(255, 0, 0);
    public static FourBitColor Pink = new FourBitColor(255, 0, 255);
    public static FourBitColor Teal = new FourBitColor(0, 128, 128);
    public static FourBitColor Green = new FourBitColor(0, 128, 0);
    public static FourBitColor BrightGreen = new FourBitColor(0, 255, 0);
    public static FourBitColor Turquoise = new FourBitColor(0, 255, 255);
    public static FourBitColor DarkBlue = new FourBitColor(0, 0, 128);
    public static FourBitColor Violet = new FourBitColor(128, 0, 128);
    public static FourBitColor Blue = new FourBitColor(0, 0, 255);
    public static FourBitColor DarkYellow = new FourBitColor(128, 128, 0);
    public static FourBitColor Yellow = new FourBitColor(255, 255, 0);
    public static FourBitColor Alpha = new FourBitColor(true);
}
