package RunningFromChaos;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.event.KeyEvent;
import java.io.IOException;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JPanel;
import javazoom.jl.player.advanced.AdvancedPlayer;

public class GraphicWindow extends JPanel {

    private Picture splash, menu;
    private Picture MapBack, MapWall, MapTop;
    private Picture Left, Right, Up, Down;
    private Picture Box, Apple, Cloud;
    private Picture[] Player1, Player2;
    private int Speed = 15;
    private int SelectedItemTop = 0;
    private Thread updateCicle;
    private AdvancedPlayer ap;
    private Symbols alph;
    private String[] menuItems = {"CONTINUE", "START SINGLEPLAYER", "START MULTIPLAYER", "ABOUT", "QUIT"};
    private GameState gameState;
    private boolean gameIsStarted = false;
    private boolean gameIsMultiplayer = false;
    private KeyboardState keyboardState = new KeyboardState();
    private PlayerState playerState1, playerState2;
    private Rectangle player1Rect, player2Rect;
    private byte Player1Site, Player2Site;
    private Mob[] Boxes;
    private Mob[] Apples;
    private Mob[] Clouds;

    ;
    
    private enum GameState {

        MainMenu, About, Splash, IsPlayingSingle, IsPlayingMultiplayer, SingleIntro, MultiIntro, Win, Lose
    }

    public GraphicWindow() throws IOException {
        super(true);
        gameState = GameState.Splash;
        updateCicle = new Thread(new Runnable() {
            @Override
            public void run() {
                while (true) {
                    try {
                        Update();
                    } catch (InterruptedException ex) {
                    }
                    try {
                        Thread.sleep(Speed);
                    } catch (InterruptedException e) {
                    }
                }
            }
        });
        updateCicle.start();
        splash = new Picture("Textures/Splash.txt");
        menu = new Picture("Textures/Menu.txt");
        MapBack = new Picture("Textures/Back.txt");
        MapWall = new Picture("Textures/Wall.txt");
        MapTop = new Picture("Textures/Sky.txt");
        Player1 = new Picture[2];
        Player2 = new Picture[2];
        Player1[1] = new Picture("Textures/Skin1Right.txt");
        Player2[1] = new Picture("Textures/Skin2Right.txt");
        Player1[0] = new Picture("Textures/Skin1Left.txt");
        Player2[0] = new Picture("Textures/Skin2Left.txt");
        Up = new Picture("Textures/Up.txt");
        Down = new Picture("Textures/Down.txt");
        Left = new Picture("Textures/Left.txt");
        Right = new Picture("Textures/Right.txt");
        Box = new Picture("Textures/Box.txt");
        Apple = new Picture("Textures/Apples.txt");
        Cloud = new Picture("Textures/Cloud.txt");
        alph = new Symbols();

        Boxes = new Mob[3];
        Apples = new Mob[6];
        Clouds = new Mob[4];

        Player1Site = 1;
        Player2Site = 1;
        Music.Play("Soundtracks/Back.mp3");
    }

    public void Resize() {
        if (!gameIsMultiplayer) {
            player1Rect = new Rectangle(0, 0, super.getWidth(), super.getHeight());
        } else {
            player1Rect = new Rectangle(0, 0, super.getWidth() / 2, super.getHeight());
            player2Rect = new Rectangle(super.getWidth() / 2, 0, super.getWidth() / 2, super.getHeight());
        }
    }

    private void SplashUpdate() {
        if (keyboardState.LastPressedKey != 0) {
            gameState = GameState.MainMenu;
        }
    }

    private void AboutUpdate() {
        if (keyboardState.LastPressedKey != 0) {
            gameState = GameState.MainMenu;
        }
    }
    
        private void SingleIntroUpdate() {
        if (keyboardState.LastPressedKey != 0) {
            gameState = GameState.IsPlayingSingle;
        }
    }
        
                private void MultiIntroUpdate() {
        if (keyboardState.LastPressedKey != 0) {
            gameState = GameState.IsPlayingMultiplayer;
        }
    }
    
        private void WinUpdate() throws InterruptedException {
            updateCicle.sleep(5000);
            gameState = GameState.MainMenu;
            gameIsStarted=false;
    }

    private void LoseUpdate() throws InterruptedException {
            updateCicle.sleep(5000);
            gameState = GameState.MainMenu;
             gameIsStarted=false;
    }

    private void PersonUpdate() {
        int deltaX = 0;
        int deltaY = 0;
        for (int i = 0; i < Boxes.length; i++) {
            if (gameIsMultiplayer) {
                Boxes[i].update(playerState1, playerState2);
            } else {
                Boxes[i].update(playerState1);
            }
            if (!Box.Intersect(Boxes[i].x + Boxes[i].dx, Boxes[i].y, 0, 0, MapWall)) {
                if (Boxes[i].x + Boxes[i].dx > 0 && Boxes[i].x + Boxes[i].dx < MapWall.getSize() - Box.getSize()) {
                    Boxes[i].x += Boxes[i].dx;
                }
            }
            if (!Box.Intersect(Boxes[i].x, Boxes[i].y + Boxes[i].dy, 0, 0, MapWall)) {
                if (Boxes[i].y + Boxes[i].dy > 0 && Boxes[i].y + Boxes[i].dy < MapWall.getSize() - Box.getSize()) {
                    Boxes[i].y += Boxes[i].dy;
                }
            }
        }
        for (int i = 0; i < Apples.length; i++) {
            if (gameIsMultiplayer) {
                Apples[i].update(playerState1, playerState2);
            } else {
                Apples[i].update(playerState1);
            }
            if (!Apple.Intersect(Apples[i].x + Apples[i].dx, Apples[i].y, 0, 0, MapWall)) {
                if (Apples[i].x + Apples[i].dx > 0 && Apples[i].x + Apples[i].dx < MapWall.getSize() - Apple.getSize()) {
                    Apples[i].x += Apples[i].dx;
                }
            }
            if (!Apple.Intersect(Apples[i].x, Apples[i].y + Apples[i].dy, 0, 0, MapWall)) {
                if (Apples[i].y + Apples[i].dy > 0 && Apples[i].y + Apples[i].dy < MapWall.getSize() - Apple.getSize()) {
                    Apples[i].y += Apples[i].dy;
                }
            }
        }
        for (int i = 0; i < Clouds.length; i++) {
            if (gameIsMultiplayer) {
                Clouds[i].update(playerState1, playerState2);
            } else {
                Clouds[i].update(playerState1);
            }

            if (!Cloud.Intersect(Clouds[i].x + Clouds[i].dx, Clouds[i].y, 0, 0, MapWall)) {
                if (Clouds[i].x + Clouds[i].dx > 0 && Clouds[i].x + Clouds[i].dx < MapWall.getSize() - Cloud.getSize()) {
                    Clouds[i].x += Clouds[i].dx;
                }
            }
            if (!Cloud.Intersect(Clouds[i].x, Clouds[i].y + Clouds[i].dy, 0, 0, MapWall)) {
                if (Clouds[i].y + Clouds[i].dy > 0 && Clouds[i].y + Clouds[i].dy < MapWall.getSize() - Cloud.getSize()) {
                    Clouds[i].y += Clouds[i].dy;
                }
            }
        }

        if (playerState1.happyFull > 1) {
            if (keyboardState.Keys[37]) {
                deltaX--;
            }
            if (keyboardState.Keys[38]) {
                deltaY--;
            }
            if (keyboardState.Keys[39]) {
                deltaX++;
            }
            if (keyboardState.Keys[40]) {
                deltaY++;
            }

            if (!(Player1[Player1Site].Intersect(playerState1.x + deltaX, playerState1.y + deltaY, 0, 0, MapWall) || Player1[Player1Site].Intersect(playerState1.x + deltaX, playerState1.y + deltaY, playerState2.x, playerState2.y, Player2[Player2Site]))) {

                playerState1.x = playerState1.x + deltaX;
                playerState1.y = playerState1.y + deltaY;
            }

            if (deltaX > 0) {
                if (Player1Site != 1) {
                    if (!(Player1[1].Intersect(playerState1.x, playerState1.y, 0, 0, MapWall))) {
                        Player1Site = 1;
                    }
                }
            }

            if (deltaX < 0) {
                if (Player1Site != 0) {
                    if (!(Player1[0].Intersect(playerState1.x, playerState1.y, 0, 0, MapWall))) {
                        Player1Site = 0;

                    }
                }
            }
        }
        
        
        if (gameIsMultiplayer) {
            if (playerState2.happyFull > 1) {
                deltaX = 0;
                deltaY = 0;
                if (keyboardState.Keys[83]) {
                    deltaY++;
                }
                if (keyboardState.Keys[65]) {
                    deltaX--;
                }
                if (keyboardState.Keys[87]) {
                    deltaY--;
                }
                if (keyboardState.Keys[68]) {
                    deltaX++;
                }
                if (!(Player2[Player2Site].Intersect(playerState2.x + deltaX, playerState2.y + deltaY, 0, 0, MapWall) || Player2[Player2Site].Intersect(playerState2.x + deltaX, playerState2.y + deltaY, playerState1.x, playerState1.y, Player1[Player1Site]))) {
                    playerState2.x = playerState2.x + deltaX;
                    playerState2.y = playerState2.y + deltaY;
                }


                if (deltaX > 0) {
                    if (Player2Site != 1) {
                        if (!(Player2[1].Intersect(playerState2.x, playerState2.y, 0, 0, MapWall))) {
                            Player2Site = 1;
                        }
                    }
                }

                if (deltaX < 0) {
                    if (Player2Site != 0) {
                        if (!(Player2[0].Intersect(playerState2.x, playerState2.y, 0, 0, MapWall))) {
                            Player2Site = 0;

                        }
                    }
                }
            }
            if (playerState1.happyFull==1 || playerState2.happyFull==1)
                gameState=GameState.Lose;
            if (playerState1.x>MapBack.getSize()-50 && playerState1.y>MapBack.getSize()-50 && playerState2.x>MapBack.getSize()-50 && playerState2.y>MapBack.getSize()-50)
                gameState = gameState=GameState.Win;
        }
        else
        {
            if (playerState1.happyFull==1)
                gameState=GameState.Lose;
            if (playerState1.x>MapBack.getSize()-50 && playerState1.y>MapBack.getSize()-50)
                gameState = gameState=GameState.Win;
        }
    }

    private void MainMenuUpdate() {
        if (keyboardState.LastPressedKey == 10 || keyboardState.LastPressedKey == 32) {
            int x;
            if (gameIsStarted) {
                x = SelectedItemTop;
            } else {
                x = SelectedItemTop + 1;
            }
            switch (x) {
                case 0:
                    if (gameIsMultiplayer) {
                        gameState = GameState.IsPlayingMultiplayer;
                    } else {
                        gameState = GameState.IsPlayingSingle;
                    }
                    break;

                case 1:
                    gameIsMultiplayer = false;
                    newGame();
                    break;

                case 2:
                    gameIsMultiplayer = true;
                    newGame();
                    break;

                case 3:
                    gameState = GameState.About;
                    System.out.println("ABOUT STARTED");
                    break;

                case 4:
                    quit();
                    break;
            }
        }

        if (keyboardState.LastPressedKey == 38) {
            SelectedItemTop--;
        }
        if (keyboardState.LastPressedKey == 40) {
            SelectedItemTop++;
        }

        byte i;

        if (gameIsStarted) {
            i = 0;
        } else {
            i = 1;
        }

        if (SelectedItemTop < 0) {
            SelectedItemTop = menuItems.length - 1 - i;
        }
        if (SelectedItemTop > menuItems.length - 1 - i) {
            SelectedItemTop = 0;
        }
    }

    public void Update() throws InterruptedException {
        switch (gameState) {
            case IsPlayingSingle:
                PersonUpdate();
                break;
            case IsPlayingMultiplayer:
                PersonUpdate();
                break;
            case Splash:
                SplashUpdate();
                break;
            case About:
                AboutUpdate();
                break;
            case MainMenu:
                MainMenuUpdate();
                break;
            case Win:
                LoseUpdate();
                break;
            case Lose:
                WinUpdate();
                break;
                case SingleIntro:
                SingleIntroUpdate();
                break;
            case MultiIntro:
                MultiIntroUpdate();
                break;
        }
        keyboardState.LastPressedKey = 0;
        this.repaint();
    }

    public void KeyDown(KeyEvent ev) {
        keyboardState.Down(ev.getKeyCode());
    }

    public void KeyUp(KeyEvent ev) {
        keyboardState.Up(ev.getKeyCode());
    }

    private void quit() {
        Runtime.getRuntime().exit(1);
    }

    private void newGame() {
        gameIsStarted = true;
        playerState1 = new PlayerState(45, 65);
        if (!gameIsMultiplayer) {
            playerState2 = new PlayerState(-55, -5);
            gameState = GameState.SingleIntro;
            player1Rect = new Rectangle(0, 0, super.getWidth(), super.getHeight());
        } else {
            playerState2 = new PlayerState(50, 5);
            gameState = GameState.MultiIntro;
            player1Rect = new Rectangle(0, 0, super.getWidth() / 2, super.getHeight());
            player2Rect = new Rectangle(super.getWidth() / 2, 0, super.getWidth() / 2, super.getHeight());
        }
        
        Random rnd = new Random();
        for (int i = 0; i < Boxes.length; i++) {
            int j1, j2;
            do {
                j1 = rnd.nextInt(MapBack.getSize() - 150) + 150;
                j2 = rnd.nextInt(MapBack.getSize() - 150) + 150;
            } while (Box.Intersect(j1, j2, 0, 0, MapWall));
            Boxes[i] = new Mob(j1, j2, 100, false, false);
        }

        for (int i = 0; i < Apples.length; i++) {
            int j1, j2;
            do {
                j1 = rnd.nextInt(MapBack.getSize() - 150) + 150;
                j2 = rnd.nextInt(MapBack.getSize() - 150) + 150;
            } while (Apple.Intersect(j1, j2, 0, 0, MapWall));
            Apples[i] = new Mob
                    (j1, j2, 100, true, true);
        }

        for (int i = 0; i < Clouds.length; i++) {
            int j1, j2;
            do {
                j1 = rnd.nextInt(MapBack.getSize() - 150) + 150;
                j2 = rnd.nextInt(MapBack.getSize() - 150) + 150;
            } while (Cloud.Intersect(j1, j2, 0, 0, MapWall));
            Clouds[i] = new Mob(j1, j2, 100, true, false);
        }
    }

    private void drawSplash(Graphics2D g2) {
        alph.Draw(g2, "HELLO EVERYPONY!", 2, 2);
        alph.Draw(g2, "PRESS ANY KEY...", 2, 10);
        splash.Draw(g2, (super.getWidth() / splash.PixelSize - splash.getSize()) / 2, (super.getHeight() / splash.PixelSize - splash.getSize()) / 2 + 4);
    }

    private void drawMenu(Graphics2D g2) {
        alph.Draw(g2, "M E N U", 30, 2);
        alph.Draw(g2, "M E N U", 31, 2);
        for (int i = 1; i < menuItems.length; i++) {
            alph.Draw(g2, menuItems[i], 15, i * 9 + 6);
            if (SelectedItemTop == i - 1) {
                alph.Draw(g2, menuItems[i], 16, i * 9 + 6);
            }
        }
        menu.Draw(g2, 0, 0);
    }

    private void drawAbout(Graphics2D g2) {
        alph.Draw(g2, "A B O U T", 30, 2);
        alph.Draw(g2, "A B O U T", 31, 2);
        alph.Draw(g2, "RUNNING FROM CHAOS", 10, 10);
        alph.Draw(g2, "BY LEMON LIGHT", 10, 18);
        alph.Draw(g2, "5-6 OCT 2012", 10, 26);
        alph.Draw(g2, "SPECIAL FOR ", 10, 34);
        alph.Draw(g2, "MY LITTLE GAME JAM 1", 10, 42);
        menu.Draw(g2, 0, 0);
    }

    private void DrawGUI(Graphics2D g2) {
        Rectangle rect = player1Rect;
        for (int i = 0; i < super.getWidth() / Up.PixelSize / Up.getSize() + 1; i++) {
            Up.Draw(g2, i * Up.getSize(), 0);
            Down.Draw(g2, i * Up.getSize(), super.getHeight() / Up.PixelSize - Down.getSize() + 1);
        }

        for (int i = 0; i < super.getHeight() / Left.PixelSize + 1; i++) {
            Left.Draw(g2, 0, i * Left.getSize());
            Right.Draw(g2, rect.width / Right.PixelSize - Right.getSize() + 1, i * Right.getSize());

            if (gameIsMultiplayer) {
                Left.Draw(g2, rect.width / Right.PixelSize, i * Left.getSize());
                Right.Draw(g2, (rect.width + player2Rect.width) / Right.PixelSize - Right.getSize() + 1, i * Right.getSize());
            }
        }

        //if (gameIsMultiplayer)

        //for (int i=0; i<super.getWidth()/Up.PixelSize/Up.getSize()+1; i++)
        //    Up.Draw(g2, i*Up.getSize(), 0);

        //Left, Right, Up, Down;
    }

    private void drawWorld(Graphics2D g2) {
        int MapPosX, MapPosY;

        Rectangle rect = player1Rect;
        PlayerState ps = playerState1;
        MapPosX = Math.min(MapBack.getSize() - rect.width / MapBack.PixelSize, Math.max(0, ps.x - rect.width / (MapBack.PixelSize * 2)));
        MapPosY = Math.min(MapBack.getSize() - rect.height / MapBack.PixelSize, Math.max(0, ps.y - rect.height / (MapBack.PixelSize * 2)));

        MapBack.Draw(g2,
                rect.x / MapBack.PixelSize, rect.y / MapBack.PixelSize,
                MapPosX, MapPosY,
                MapPosX + rect.width / MapBack.PixelSize, MapPosY + rect.height / MapBack.PixelSize, ps.Colorful());



        for (int i = 0; i < Boxes.length; i++) {
            if (Boxes[i].x > MapPosX && Boxes[i].x < MapPosX + rect.width / Box.PixelSize - Box.getSize()) {
                if (Boxes[i].y > MapPosY && Boxes[i].y < MapPosY + rect.height / Box.PixelSize) {
                    Box.Draw(g2,
                            Boxes[i].x - MapPosX, Boxes[i].y - MapPosY, ps.Colorful());
                }
            }
        }
        for (int i = 0; i < Apples.length; i++) {
            if (Apples[i].x > MapPosX && Apples[i].x < MapPosX + rect.width / Apple.PixelSize - Apple.getSize()) {
                if (Apples[i].y > MapPosY && Apples[i].y < MapPosY + rect.height / Apple.PixelSize) {
                    Apple.Draw(g2,
                            Apples[i].x - MapPosX, Apples[i].y - MapPosY, ps.Colorful());
                }
            }
        }
        for (int i = 0; i < Clouds.length; i++) {
            if (Clouds[i].x > MapPosX && Clouds[i].x < MapPosX + rect.width / Cloud.PixelSize - Cloud.getSize()) {
                if (Clouds[i].y > MapPosY && Clouds[i].y < MapPosY + rect.height / Cloud.PixelSize) {
                    Cloud.Draw(g2,
                            Clouds[i].x - MapPosX, Clouds[i].y - MapPosY, ps.Colorful());
                }
            }
        }




        MapWall.Draw(g2,
                rect.x / MapBack.PixelSize, rect.y / MapBack.PixelSize,
                MapPosX, MapPosY,
                MapPosX + rect.width / MapBack.PixelSize, MapPosY + rect.height / MapBack.PixelSize, ps.Colorful());

        Player1[Player1Site].Draw(g2, rect.x / MapBack.PixelSize + ps.x - MapPosX, ps.y - MapPosY, ps.Colorful());

        if (gameIsMultiplayer) {
            if (rect.x / MapBack.PixelSize + playerState2.x - MapPosX + Player2[Player2Site].getSize() < rect.width / MapBack.PixelSize && rect.x / MapBack.PixelSize + playerState2.x - MapPosX > -Player2[Player2Site].getSize()) {
                Player2[Player2Site].Draw(g2, rect.x / MapBack.PixelSize + playerState2.x - MapPosX, playerState2.y - MapPosY, playerState2.Colorful());
            }
        }

        MapTop.Draw(g2,
                rect.x / MapBack.PixelSize, rect.y / MapBack.PixelSize,
                MapPosX, MapPosY,
                MapPosX + rect.width / MapBack.PixelSize, MapPosY + rect.height / MapBack.PixelSize, ps.Colorful());

        if (gameIsMultiplayer) {
            rect = player2Rect;
            ps = playerState2;
            MapPosX = Math.min(MapBack.getSize() - rect.width / MapBack.PixelSize, Math.max(0, ps.x - rect.width / (MapBack.PixelSize * 2)));
            MapPosY = Math.min(MapBack.getSize() - rect.height / MapBack.PixelSize, Math.max(0, ps.y - rect.height / (MapBack.PixelSize * 2)));

            MapBack.Draw(g2,
                    rect.x / MapBack.PixelSize, rect.y / MapBack.PixelSize,
                    MapPosX, MapPosY,
                    MapPosX + rect.width / MapBack.PixelSize, MapPosY + rect.height / MapBack.PixelSize, ps.Colorful());



            for (int i = 0; i < Boxes.length; i++) {
                if (Boxes[i].x > MapPosX && Boxes[i].x < MapPosX + rect.width / Box.PixelSize) {
                    if (Boxes[i].y > MapPosY && Boxes[i].y < MapPosY + rect.height / Box.PixelSize) {
                        Box.Draw(g2,
                                rect.x / Box.PixelSize + Boxes[i].x - MapPosX, Boxes[i].y - MapPosY, ps.Colorful());
                    }
                }
            }
            for (int i = 0; i < Apples.length; i++) {
                if (Apples[i].x > MapPosX && Apples[i].x < MapPosX + rect.width / Apple.PixelSize) {
                    if (Apples[i].y > MapPosY && Apples[i].y < MapPosY + rect.height / Apple.PixelSize) {
                        Apple.Draw(g2,
                                rect.x / Apple.PixelSize + Apples[i].x - MapPosX, Apples[i].y - MapPosY, ps.Colorful());
                    }
                }
            }
            for (int i = 0; i < Clouds.length; i++) {
                if (Clouds[i].x > MapPosX && Clouds[i].x < MapPosX + rect.width / Cloud.PixelSize) {
                    if (Clouds[i].y > MapPosY && Clouds[i].y < MapPosY + rect.height / Cloud.PixelSize) {
                        Cloud.Draw(g2,
                                rect.x / Cloud.PixelSize + Clouds[i].x - MapPosX, Clouds[i].y - MapPosY, ps.Colorful());
                    }
                }
            }





            MapWall.Draw(g2,
                    rect.x / MapBack.PixelSize, rect.y / MapBack.PixelSize,
                    MapPosX, MapPosY,
                    MapPosX + rect.width / MapBack.PixelSize, MapPosY + rect.height / MapBack.PixelSize, ps.Colorful());

            Player2[Player2Site].Draw(g2, rect.x / MapBack.PixelSize + ps.x - MapPosX, ps.y - MapPosY, ps.Colorful());
            if (rect.x / MapBack.PixelSize + playerState1.x - MapPosX > (rect.x - Player1[Player1Site].PixelSize) / MapBack.PixelSize && rect.x / MapBack.PixelSize + playerState1.x - MapPosX < (rect.x + rect.width) / MapBack.PixelSize) {
                Player1[Player1Site].Draw(g2, rect.x / MapBack.PixelSize + playerState1.x - MapPosX, playerState1.y - MapPosY, playerState1.Colorful());
            }
            MapTop.Draw(g2,
                    rect.x / MapBack.PixelSize, rect.y / MapBack.PixelSize,
                    MapPosX, MapPosY,
                    MapPosX + rect.width / MapBack.PixelSize, MapPosY + rect.height / MapBack.PixelSize, ps.Colorful());
        }

        DrawGUI(g2);
    }

    private void drawWin(Graphics2D g2) {
                alph.Draw(g2, "Y O U  W I N", 30, 2);
        alph.Draw(g2, "Y O U  W I N", 31, 2);
        alph.Draw(g2, "HAVE SUCCESSFULLY", 13, 18);
        alph.Draw(g2, "ESCAPED", 13, 26);
        alph.Draw(g2, "FROM THE CHAOS!", 13, 34);
        menu.Draw(g2, 0, 0);
    }

    private void drawLose(Graphics2D g2) {
        alph.Draw(g2, "E P I C  F A I L", 30, 2);
        alph.Draw(g2, "E P I C  F A I L", 31, 2);
        alph.Draw(g2, "YOU HAVE LOST", 13, 10);
        alph.Draw(g2, "FAITH IN FRIENDSHIP!", 13, 18);
        alph.Draw(g2, "YOU LOSE...", 13, 26);
        alph.Draw(g2, "DISCORD WIN...", 13, 38);
        menu.Draw(g2, 0, 0);
    }
    
        private void drawSingleIntro(Graphics2D g2) {
        alph.Draw(g2, "RULES:", 30, 2);
        alph.Draw(g2, "RULES:", 31, 2);
        alph.Draw(g2, "YOU ARE FRINEDLY BY DEFAULT.", 13, 14);
        alph.Draw(g2, "DISCORDS APPLES", 13, 26);
        alph.Draw(g2, "MAKE YOU UNFRIENDLY. MAKE YOU GRAY.", 13, 38);
        alph.Draw(g2, "YOU CAN GET GIFTS,", 13, 50);
        alph.Draw(g2, "BUT THEY RUN AWAY FROM YOU.", 13, 62);
        alph.Draw(g2, "NOBODY WILL SAVE YOU.", 13, 74);
        alph.Draw(g2, "RUN!", 13, 86);
        menu.Draw(g2, 0, 0);
    }

    private void drawMultiIntro(Graphics2D g2) {
        alph.Draw(g2, "RULES:", 30, 2);
        alph.Draw(g2, "RULES:", 31, 2);
        alph.Draw(g2, "YOU ARE FRINEDLY BY DEFAULT.", 13, 14);
        alph.Draw(g2, "DISCORDS APPLES", 13, 26);
        alph.Draw(g2, "MAKE YOU UNFRIENDLY. MAKE YOU GRAY.", 13, 38);
        alph.Draw(g2, "YOU CAN GET GIFTS,", 13, 50);
        alph.Draw(g2, "BUT THEY RUN AWAY FROM YOU.", 13, 62);
        alph.Draw(g2, "BUT YOU ARE NOT ALONE!", 13, 74);
        alph.Draw(g2, "YOUR FRIEND CAN SAVE YOU!", 13, 86);
        alph.Draw(g2, "RUN!", 13, 98);
        alph.Draw(g2, "HINT: USE ARROWS AND W-A-S-D", 13, 110);
        menu.Draw(g2, 0, 0);
    }

    @Override
    public void paint(java.awt.Graphics g) {
        Graphics2D g2 = (Graphics2D) g.create();
        g2.setColor(Color.yellow);
        g2.fillRect(0, 0, super.getWidth(), super.getHeight());
        switch (gameState) {
            case Splash:
                drawSplash(g2);
                break;
            case MainMenu:
                drawMenu(g2);
                break;
            case About:
                drawAbout(g2);
                break;
            case IsPlayingSingle:
                drawWorld(g2);
                break;
            case IsPlayingMultiplayer:
                drawWorld(g2);
                break;
            case Win:
                drawWin(g2);
                break;
            case Lose:
                drawLose(g2);
                break;
                            case SingleIntro:
                drawSingleIntro(g2);
                break;
            case MultiIntro:
                drawMultiIntro(g2);
                break;
        }
    }
}
