package RunningFromChaos;
import java.awt.Graphics2D;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;

public class Picture {

    private ArrayList<String> Pixels;
    public int PixelSize;

    public boolean PixelIsAlpha(int x, int y) {
        if (Pixels.get(x).charAt(y) == 'A') {
            return true;
        } else {
            return false;
        }
    }

    public int getSize() {
        return Pixels.size();
    }

    public Picture(String name) throws IOException {
        Pixels = Others.ReadAllLines(name);
        PixelSize = 4;
    }

    public boolean Intersect(int x1, int y1, int x2, int y2, Picture pict) {
        int x3, y3, x4, y4;
        x3 = Math.min(x1, x2) + Math.abs(x1 - x2);
        y3 = Math.min(y1, y2) + Math.abs(y1 - y2);
        x4 = Math.min(x1 + Pixels.size(), x2 + pict.getSize());
        y4 = Math.min(y1 + Pixels.size(), y2 + pict.getSize());

        for (int i = 0; i < x4 - x3; i++) {
            for (int j = 0; j < y4 - y3; j++) {

                if (!(PixelIsAlpha(y3 - y1 + j, x3 - x1 + i) || pict.PixelIsAlpha(y3 - y2 + j, x3 - x2 + i))) {
                    return true;
                }
            }
        }
        return false;
    }

    public void Draw(Graphics2D g2, int x, int y) {
        for (int j = 0; j < Pixels.get(0).length(); j++) {
            for (int i = 0; i < Pixels.size(); i++) {
                if (!FourBitColor.ColorFromChar(Pixels.get(i).charAt(j)).A) {
                    g2.setColor(FourBitColor.ColorFromChar(Pixels.get(i).charAt(j)).ToAWT());
                    g2.fillRect((j + x) * PixelSize, (i + y) * PixelSize, PixelSize, PixelSize);

                }
            }
        }

    }

    public void Draw(Graphics2D g2, int x, int y, byte colorfull) {
        for (int j = 0; j < Pixels.get(0).length(); j++) {
            for (int i = 0; i < Pixels.size(); i++) {
                if (!FourBitColor.ColorFromChar(Pixels.get(i).charAt(j)).A) {
                    switch (colorfull) {
                        case 2:
                            g2.setColor(FourBitColor.ColorFromChar(Pixels.get(i).charAt(j)).ToAWT());
                            break;
                        case 1:
                            g2.setColor(FourBitColor.GrayColorFromChar(Pixels.get(i).charAt(j)).ToAWT());
                            break;
                        case 0:
                            g2.setColor(FourBitColor.BlackColorFromChar(Pixels.get(i).charAt(j)).ToAWT());
                    }


                    g2.fillRect((j + x) * PixelSize, (i + y) * PixelSize, PixelSize, PixelSize);

                }
            }
        }
    }

    //REAL SIZE MUST BE MORE OR AS A SIZEX & SIZEY
    public void Draw(Graphics2D g2, int x, int y, int PosX, int PosY, int SizeX, int SizeY, byte colorfull) {
        for (int j = Math.max(0, Math.min(PosX, Pixels.size() - 1)); j < Math.max(0, Math.min(SizeX, Pixels.size())); j++) {
            for (int i = Math.max(0, Math.min(PosY, Pixels.size() - 1)); i < Math.max(0, Math.min(SizeY, Pixels.size())); i++) {
                if (!FourBitColor.ColorFromChar(Pixels.get(i).charAt(j)).A) {
                    switch (colorfull) {
                        case 2:
                            g2.setColor(FourBitColor.ColorFromChar(Pixels.get(i).charAt(j)).ToAWT());
                            break;
                        case 1:
                            g2.setColor(FourBitColor.GrayColorFromChar(Pixels.get(i).charAt(j)).ToAWT());
                            break;
                        case 0:
                            g2.setColor(FourBitColor.BlackColorFromChar(Pixels.get(i).charAt(j)).ToAWT());
                    }
                    g2.fillRect((j + x - Math.max(0, Math.min(PosX, Pixels.size() - 1))) * PixelSize, (i + y - Math.max(0, Math.min(PosY, Pixels.size() - 1))) * PixelSize, PixelSize, PixelSize);
                }
            }
        }

    }
}
